/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.msp.IGetRolesCallBack
 *  fire.pb.item.MailInfo
 *  fire.pb.item.SMailInfo
 *  fire.pb.map.RoleManager
 *  mkdb.Lockey
 *  mkdb.Lockeys
 *  mkdb.Procedure
 *  mkdb.TTable
 *  mkio.Protocol
 *  xbean.Pod
 *  xbean.SingleCompensation
 *  xbean.SingleCompensationAward
 *  xbean.SingleCompensationCond
 *  xtable.Locks
 *  xtable.Singlecompensations
 */
package fire.pb.compensation;

import fire.msp.IGetRolesCallBack;
import fire.pb.compensation.CompensationCondition;
import fire.pb.compensation.CompensationManager;
import fire.pb.compensation.CompensationRole;
import fire.pb.compensation.CompensationToMail;
import fire.pb.compensation.Helper;
import fire.pb.compensation.Module;
import fire.pb.item.MailInfo;
import fire.pb.item.SMailInfo;
import fire.pb.map.RoleManager;
import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import mkdb.Lockey;
import mkdb.Lockeys;
import mkdb.Procedure;
import mkdb.TTable;
import mkio.Protocol;
import xbean.Pod;
import xbean.SingleCompensation;
import xbean.SingleCompensationAward;
import xbean.SingleCompensationCond;
import xtable.Locks;
import xtable.Singlecompensations;

public class PGiveSingleCompensition
extends Procedure {
    private final Set<Long> roleIds;
    private final List<SingleCompensationAward> awards;
    private final String title;
    private final String content;
    private long endTime = 0L;
    private int giveType = 0;
    private Map<Integer, List<String>> conds = null;
    private String opid = "";
    private String sign = "";
    private long compensekey;

    public PGiveSingleCompensition(Set<Long> roleIds, List<SingleCompensationAward> awards, String title, String content, Map<Integer, List<String>> conds) {
        this.roleIds = roleIds;
        this.awards = awards;
        this.title = title;
        this.content = content;
        this.conds = conds;
    }

    public static PGiveSingleCompensition createFromActivity(Set<Long> roleIds, List<SingleCompensationAward> awards, String title, String content, long endTime) {
        PGiveSingleCompensition proc = new PGiveSingleCompensition(roleIds, awards, title, content, null);
        proc.endTime = endTime;
        return proc;
    }

    public static PGiveSingleCompensition createFromYunYing(Set<Long> roleIds, List<SingleCompensationAward> awards, String title, String content, long endTime, String opid, String sign) {
        PGiveSingleCompensition proc = new PGiveSingleCompensition(roleIds, awards, title, content, null);
        proc.endTime = endTime;
        proc.opid = opid;
        proc.sign = sign;
        return proc;
    }

    public static PGiveSingleCompensition createFromYunYingCond(Map<Integer, List<String>> conds, List<SingleCompensationAward> awards, String title, String content, long endTime, String opid, String sign) {
        PGiveSingleCompensition proc = new PGiveSingleCompensition(new HashSet<Long>(), awards, title, content, conds);
        proc.endTime = endTime;
        proc.opid = opid;
        proc.sign = sign;
        proc.giveType = 1;
        return proc;
    }

    protected boolean process() throws Exception {
        SingleCompensation xcompens = Pod.newSingleCompensation();
        xcompens.setTime(System.currentTimeMillis());
        xcompens.setValidtime(this.endTime);
        xcompens.setTitle(this.title);
        xcompens.setContent(this.content);
        xcompens.setOpid(this.opid);
        xcompens.setSign(this.sign);
        for (SingleCompensationAward singleCompensationAward : this.awards) {
            SingleCompensationAward newAward = Pod.newSingleCompensationAward();
            newAward.setType(singleCompensationAward.getType());
            newAward.setId(singleCompensationAward.getId());
            newAward.setNum(singleCompensationAward.getNum());
            newAward.setFlag(singleCompensationAward.getFlag());
            xcompens.getAwards().add(newAward);
        }
        xcompens.setGivetype(this.giveType);
        if (this.giveType == 0) {
            xcompens.getRoleids().addAll(this.roleIds);
        } else if (this.giveType == 1) {
            if (this.conds == null) {
                return false;
            }
            for (Map.Entry entry : this.conds.entrySet()) {
                SingleCompensationCond cond = Pod.newSingleCompensationCond();
                cond.setCondid(((Integer)entry.getKey()).intValue());
                cond.getCondparams().addAll((Collection)entry.getValue());
                xcompens.getConditions().add(cond);
            }
        }
        this.compensekey = Singlecompensations.insert((SingleCompensation)xcompens);
        if (this.giveType == 0) {
            PGiveSingleCompensition.giveOfRoles(xcompens, this.compensekey, this.giveType);
        } else if (this.giveType == 1) {
            PGiveSingleCompensition.giveOfCond(xcompens, this.compensekey, this.giveType);
        }
        return true;
    }

    public long getCompensekey() {
        return this.compensekey;
    }

    public void setCompensekey(long compensekey) {
        this.compensekey = compensekey;
    }

    private static void giveOfRoles(SingleCompensation xcompens, long compensekey, int giveType) {
        Lockeys.lock((Lockey[])Lockeys.get((TTable)Locks.COMPENSATIONROLES, (Collection)xcompens.getRoleids()));
        Iterator iterator = xcompens.getRoleids().iterator();
        while (iterator.hasNext()) {
            long roleId = (Long)iterator.next();
            Procedure proc = PGiveSingleCompensition.giveOfRole(roleId, compensekey, giveType, true);
            proc.call();
        }
        PGiveSingleCompensition.onLog(xcompens, compensekey, giveType);
    }

    private static void giveOfCond(SingleCompensation xcompens, final long compensekey, final int giveType) {
        Module.addGiveKeyRecord(compensekey, new HashSet<Long>());
        RoleManager.getRolesByConditions((int)-1, (int)-1, (int)-1, (long)-1L, (int)-1, (IGetRolesCallBack)new IGetRolesCallBack(){

            public void process(List<Long> roleIds) {
                List<CompensationCondition> conditions = PGiveSingleCompensition.getCondition(compensekey);
                for (Long roleId : roleIds) {
                    Procedure proc;
                    if (!CompensationManager.getInstance().checkCondition(conditions, roleId)) {
                        proc = Helper.roleToExcept(compensekey, roleId);
                        Procedure.pexecuteWhileCommit((Procedure)proc);
                        continue;
                    }
                    proc = PGiveSingleCompensition.giveOfRole(roleId, compensekey, giveType, true);
                    Procedure.pexecuteWhileCommit((Procedure)proc);
                }
            }
        });
        PGiveSingleCompensition.onLog(xcompens, compensekey, giveType);
    }

    public static Procedure giveOfRole(final long roleId, final long compensekey, final int giveType, final boolean isSendMailInfo) {
        Procedure proc = new Procedure(){

            protected boolean process() {
                MailInfo mailInfo;
                CompensationRole role;
                if (giveType == 1) {
                    Module.addGiveRoleId(compensekey, roleId);
                    SingleCompensation xsingle = Singlecompensations.get((Long)compensekey);
                    if (xsingle != null) {
                        xsingle.getRoleidsofget().add(roleId);
                    }
                }
                if ((role = CompensationRole.getSingleCompensation(roleId, false)) == null) {
                    return false;
                }
                role.giveCompensition(compensekey);
                if (isSendMailInfo && (mailInfo = CompensationToMail.SingleCompensation2Mail(role, compensekey)) != null) {
                    SMailInfo send = new SMailInfo();
                    send.mail = mailInfo;
                    Procedure.psendWhileCommit((long)roleId, (Protocol)send);
                }
                return true;
            }
        };
        return proc;
    }

    public static List<CompensationCondition> getCondition(long compensekey) {
        LinkedList<CompensationCondition> conditions = new LinkedList<CompensationCondition>();
        SingleCompensation xsingle = Singlecompensations.select((Long)compensekey);
        if (xsingle != null) {
            for (SingleCompensationCond cond : xsingle.getConditions()) {
                String[] strings = new String[cond.getCondparams().size() + 1];
                strings[0] = String.valueOf(cond.getCondid());
                int i = 1;
                for (int c = 0; i < strings.length && c < cond.getCondparams().size(); ++i, ++c) {
                    strings[i] = (String)cond.getCondparams().get(c);
                }
                conditions.add(new CompensationCondition(strings));
            }
        }
        return conditions;
    }

    public static void onLog(SingleCompensation xcompens, long compensekey, int givetype) {
        if (Module.logger.isInfoEnabled()) {
            String itemDetails = "";
            String otherDetails = "";
            for (SingleCompensationAward award : xcompens.getAwards()) {
                switch (award.getType()) {
                    case 0: {
                        itemDetails = itemDetails + "[" + award.getId() + "," + award.getNum() + "," + award.getFlag() + "],";
                        break;
                    }
                    case 1: {
                        otherDetails = otherDetails + " MONEY=" + award.getNum();
                        break;
                    }
                    case 2: {
                        otherDetails = otherDetails + " GOLD=" + award.getNum();
                        break;
                    }
                    case 3: {
                        otherDetails = otherDetails + " FUSHI=" + award.getNum();
                        break;
                    }
                    case 4: {
                        otherDetails = otherDetails + " EXP=" + award.getNum();
                        break;
                    }
                    case 5: {
                        otherDetails = otherDetails + " VIPEXP=" + award.getNum();
                        break;
                    }
                }
            }
            SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String strStartTime = dateFormat.format(xcompens.getTime());
            String strEndTime = xcompens.getValidtime() > 0L ? dateFormat.format(xcompens.getValidtime()) : "0";
            String strInfo = "[Mail.PGiveSingleCompensition] givetype:" + givetype + " id:" + compensekey + " startTime:" + strStartTime + " endTime:" + strEndTime + " itemDetails:" + itemDetails + " otherDetails:" + otherDetails + " opid:" + xcompens.getOpid() + " sign:" + xcompens.getSign() + " title:" + xcompens.getTitle() + " content:" + xcompens.getContent();
            if (givetype == 0) {
                strInfo = strInfo + " roleIds:" + Arrays.toString(xcompens.getRoleids().toArray());
            } else if (givetype == 1) {
                String strCond = "";
                for (SingleCompensationCond cond : xcompens.getConditions()) {
                    if (!strCond.isEmpty()) {
                        strCond = strCond + ",";
                    }
                    strCond = strCond + cond.getCondid();
                    for (String s : cond.getCondparams()) {
                        strCond = strCond + "|" + s;
                    }
                }
                strInfo = strInfo + " conds:" + strCond;
            }
            Module.logger.info((Object)strInfo);
        }
    }
}

